.\"	$NetBSD: getty.8,v 1.16 2002/09/29 14:05:53 wiz Exp $
.\"
.\" Copyright (c) 1980, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)getty.8	8.1 (Berkeley) 6/4/93
.\"
.Dd December 12, 1998
.Dt GETTY 8
.Os
.Sh NAME
.Nm getty ,
.Nm uugetty
.Nd set terminal modes for system access
.Sh SYNOPSIS
.Nm
.Oo
.Ar type
.Op Ar tty
.Oc
.Nm uugetty
.Oo
.Ar type
.Op Ar tty
.Oc
.Sh DESCRIPTION
The
.Nm
program
is called by
.Xr init 8
to open and initialize the tty line, read a login name, and invoke
.Xr login 1 .
The devices on which to run
.Nm
are normally determined by
.Xr ttys 5 .
.Pp
The
.Nm
program can also recognize a Point to Point Protocol
.Pq Tn PPP
negotiation, and, if the
.Sy pp
attribute in
.Xr gettytab 5
is set, invoke the program given by that string, e.g.,
.Xr pppd 8 ,
instead of
.Xr login 1 .
This makes it possible to use a single serial port for either a
.Qq shell
account with command line interface, or a
.Tn PPP
network link.
.Pp
The argument
.Ar tty
is the special device file in
.Pa /dev
to open for the terminal
.Po
for example,
.Qq ttyh0
.Pc .
If there is no argument or the argument is
.Ql Fl ,
the tty line is assumed to be open as file descriptor 0.
.Pp
The
.Ar type
argument can be used to make
.Nm
treat the terminal line specially.
This argument is used as an index into the
.Xr gettytab 5
database, to determine the characteristics of the line.
If there is no argument, or there is no such table, the
.Em default
table is used.
If there is no
.Pa /etc/gettytab
a set of system defaults is used.
If indicated by the table located,
.Nm
will clear the terminal screen,
print a banner heading,
and prompt for a login name.
Usually either the banner or the login prompt will include
the system hostname.
.Pp
.Nm
uses the
.Xr ttyaction 3
facility with an action of
.Qq getty
and user
.Qq root
to execute site-specific commands when it starts.
.Pp
Most of the default actions of
.Nm
can be circumvented, or modified, by a suitable
.Xr gettytab 5
table.
.Pp
The
.Nm
program can be set to timeout after some interval,
which will cause dial up lines to hang up
if the login name is not entered reasonably quickly.
.Pp
The
.Nm uugetty
program is the same, except that it uses
.Xr pidlock 3
to respect the locks in
.Pa /var/spool/lock
of processes that dial out on that tty.
.Sh FILES
.Bl -tag -width /var/spool/lock/LCK..ttyXX -compact
.It Pa /etc/gettytab
.It Pa /etc/ttys
.It Pa /var/spool/lock/LCK..ttyXX
.El
.Sh DIAGNOSTICS
.Bl -diag
.It "ttyxx: No such device or address."
.It "ttyxx: No such file or address."
A terminal which is turned on in the
.Xr ttys 5
file cannot be opened, likely because the requisite
lines are either not configured into the system, the associated device
was not attached during boot-time system configuration,
or the special file in
.Pa /dev
does not exist.
.El
.Sh SEE ALSO
.Xr login 1 ,
.Xr ioctl 2 ,
.Xr pidlock 3 ,
.Xr ttyaction 3 ,
.Xr tty 4 ,
.Xr gettytab 5 ,
.Xr ttys 5 ,
.Xr init 8 ,
.Xr pppd 8
.Sh HISTORY
A
.Nm
program appeared in
.At v6 .
